Require Import sqrt_correct.
Require Import digits_ex.
Require Import String.
Open Scope string_scope.

Definition in_red (s:string) := 
String "027" ("[0;31;48m" ++ s++(String "027" "[0;30;48m")).


(*******************************)

Eval compute in (in_red "Benchmark using the base 2^124 ").

Module Base_2_124 <: BASE.
Definition b := (2^124)%Z.
Theorem base_positive : (4 < b)%Z.
compute; auto.
Qed.
End Base_2_124.

Module digits_test := BIGZNUMS Base_2_124.

Module Test_computations := SQRT digits_test.
(*Module Test_computations := EXACT_REAL_DEFINITIONS digits_test.*)
Import Test_computations.

(*compute the nth digit of a real*)
Fixpoint nth (A:Set) (n:nat)(s:stream A) {struct n}: A :=
  match n, s with 0%nat,(d::s') => d | (S p),(_::s') => nth A p s' end.



(* Test of Sinverse *)
Eval compute in (in_red "4th digits of 1/(base * (3/7 + 5/9))").

Time Eval vm_compute in (nth _ 20%nat 
  (Sinverse 1%nat ((Srat_to_stream (BigZ.of_Z 3) (BigZ.of_Z 7)) + (Srat_to_stream (BigZ.of_Z 5) (BigZ.of_Z 9)))%S)).

(* Test Szero *)
Eval compute in (in_red "1000th digits of Szero").

Time Eval vm_compute in (nth _ 1000%nat Szero).

(* Test of Sone *)
Eval compute in (in_red "1000th digits of Sone").

Time Eval vm_compute in (nth _ 1000%nat Sone).

(* Test of Sminus_one *)
Eval compute in (in_red "1000th digits of Sminus_one").

Time Eval vm_compute in (nth _ 1000%nat Sminus_one).

(* Test of Sopp *)
Eval compute in (in_red "1000th digits of (Sopp Sone)").

Time Eval vm_compute in (nth _ 1000%nat  (Sopp Sone) ).

(* Test of Sabs *)
Eval compute in (in_red "1000th digits of (Sabs Sminus_one)").

Time Eval vm_compute in (nth _ 1000%nat  (Sabs Sminus_one) ).

(* Test of Smin *)
Eval compute in (in_red "1000th digits of (Smin Szero Sone)").

Time Eval vm_compute in (nth _ 1000%nat (Smin Szero Sone)).

(* Test of Smax *)
Eval compute in (in_red "1000th digits of (Smax Szero Sone)").

Time Eval vm_compute in (nth _ 1000%nat (Smax Szero Sone)).

(* Test of multb *)
Eval compute in (in_red "1000th digits of (multb (1::Szero))").

Time Eval vm_compute in (nth _ 1000%nat (multb (1%D::Szero))).


(* Test of mult_digit *)
Eval compute in (in_red "1000th digits of (mult_digit (b/2) (1::Szero))").

Time Eval vm_compute in (nth _ 1000%nat (mult_digit (fst (Bdiv_eucl Bbase (1+1)%B)) (1%D::Szero))).

(* Test of div_digit *)
Eval compute in (in_red "1000th digits of (div_digit Sone 3)").

Time Eval vm_compute in (nth _ 1000%nat (div_digit Sone (1+1+1)%D)).

(* Test of Srat_to_stream *)
Eval compute in (in_red "10000th digits of 3 / 7").

Time Eval vm_compute in (nth _ 10000%nat (Srat_to_stream 3 7)).

(* Test of Sadd *)
Eval compute in (in_red "10000th digits of 3/7 + 5/9").

Time Eval vm_compute in (nth _ 10000%nat 
  ((Srat_to_stream 3 7) + (Srat_to_stream 5 9))%S).

(* Test of Smult *)
Eval compute in (in_red "100th digits of 3/7 * 5/9").

Time Eval vm_compute in (nth _ 100%nat
  ((Srat_to_stream 3 7) * (Srat_to_stream 5 9))%S).

(* Test of pi_div4 *)
Eval compute in (in_red "28th digits of pi/4").

Time Eval vm_compute in (nth _ 28%nat pi_div4).

(* Test of Sinverse' *)
Eval compute in (in_red "4th digits of 1/(base * (3/7 + 5/9))").

Time Eval vm_compute in (nth _ 4%nat 
  (Sinverse' 1%nat ((Srat_to_stream 3 7) + (Srat_to_stream 5 9))%S)).

(* template

(* Test of  *)
Eval compute in (in_red "th digits of ").

Time Eval vm_compute in (nth _ %nat   ).

*)

(* Here I put an error not to have create the compile file.
   It allows to play the benchmark several times withtout
   deleting the compiled file or touching the source*)

///