Require Export tactic.
Require Import digits_ex.

Module Base_ex <: BASE.
Definition b := (10^10)%Z.
Theorem base_positive : (4 < b)%Z.
unfold b; compute; auto.
Qed.
End Base_ex.

Module nums_ex :=  BIGZNUMS  Base_ex.

Module Test := TACTIC nums_ex.
Import Test.

Definition ex1 := (mult pi (opp (add one one))).

(*Eval compute in ex1. (* ne termine pas *)
*)

Time Eval vm_compute in Ebounds ex1 50.

Time Eval vm_compute in Ebounds ex1 51.

Theorem PI_22_7_approx : 
  Rabs (PI - 22 / 7) < 1 / 100.
Proof.
ineq_tac 2%nat.
Qed.

Goal 
  (Rabs (1 /(- 887/53) - -228/51) <= 10 / 2)%R.
  match goal with 
    |- ?a <= ?b => 
      let x := (find_representation a 10%nat) in 
      let y := (find_representation b 10%nat) in 
        apply (compare2_le 10%nat x y)
  end.

3: vm_compute; auto.

2: solve_represent 10%nat.

apply abs_correct.
apply sub_correct.
2: solve_represent 10%nat.
apply inverse_correct.
2: solve_represent 10%nat.

match goal with 
  |- ?a <= ?b => 
    let x := (find_representation a 10%nat) in 
      let y := (find_representation b 10%nat) in 
        apply (compare2_le 10%nat x y)
end.

solve_represent 10%nat.
compute; auto.
solve_represent 10%nat.
vm_compute; auto.




apply rat_to_stream_correct.










ineq_tac 10%nat.
apply invere_correct.
simplZ2R.


ineq_tac 1%nat.




Qd.

Goal 
  (Rabs (1 /(- 8871213671148155/2^53) - -2286317335542953/2^51) <= 1 / 2^53)%R.
ineq_tac 4%nat.
Qed.


